# -*- encoding: utf-8 -*-
##############################################################################
#    
#    Copyright (C) 2011 Agile Business Group sagl (<http://www.agilebg.com>)
#    Copyright (C) 2011 Domsense srl (<http://www.domsense.com>)
#    All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################

from osv import fields, osv
import datetime
import decimal_precision as dp

class account_model_line(osv.osv):

    _inherit = 'account.model.line'
    _columns = {
        'type':fields.selection([
            ('cr','Credit'),
            ('dr','Debit'),
            ], 'Type'),
        'amount': fields.float('Amount', digits_compute=dp.get_precision('Account')),
        'value_type': fields.selection([
            ('amount','Amount'),
            ('percentage','Percentage'),
            ], 'Value Type'),
    }

    def compute_amount(self,vals,amount):
    	if vals['type']=='cr' and vals['value_type']=='amount':
        	vals['credit']=vals['amount']
        elif vals['type']=='cr' and vals['value_type']=='percentage':
        	vals['credit']=(amount/100)*vals['amount']
        elif vals['type']=='dr' and vals['value_type']=='amount':
        	vals['debit']=vals['amount']
        elif vals['type']=='dr' and vals['value_type']=='percentage':
        	vals['debit']=(amount/100)*vals['amount']
        return vals

    def create(self, cr, uid, vals, context=None):
        amount = self.pool.get('account.model').browse(cr,uid,vals['model_id']).amount
        vals = self.compute_amount(vals,amount)
        return super(account_model_line, self).create(cr, uid, vals, context)

    def write(self, cr, uid, ids, vals, context=None):
        amount = self.pool.get('account.model.line').browse(cr,uid,ids[0]).model_id.amount
        vals = self.compute_amount(vals,amount)
        return super(account_model_line, self).write(cr, uid, ids, vals, context=context)
    
account_model_line()

class account_model(osv.osv):

    _inherit = 'account.model'
    _columns = {
        'amount': fields.float('Amount', digits_compute=dp.get_precision('Account')),
    }
    
account_model()